#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1800five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 1800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five18004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five18004xi = {
                1: '-1034x931y1141z',
                2: '-1035x1385y496z',
                3: '-1035x817y1224z',
                4: '-1086x769y1211z',
                5: '-1090x882y1127z',
                6: '-1110x1333y478z',
                7: '-112x6y1796z',
                8: '-1135x717y1198z',
                9: '-1143x831y1113z',
                10: '-116x556y1707z',
                11: '-1181x1277y461z',
                12: '-1182x663y1184z',
                13: '-1195x776y1099z',
                14: '-1225x605y1170z',
                15: '-1243x717y1085z',
                16: '-1250x1216y444z',
                17: '-1266x545y1157z',
                18: '-127x1211y1324z',
                19: '-1289x656y1070z',
                20: '-1303x482y1143z',
                21: '-130x0y1795z',
                22: '-1315x1152y426z',
                23: '-1331x592y1056z',
                24: '-1338x416y1129z',
                25: '-1369x348y1115z',
                26: '-1370x526y1041z',
                27: '-1377x1084y409z',
                28: '-1396x278y1101z',
                29: '-1405x456y1027z',
                30: '-1419x206y1086z',
                31: '-1435x1013y391z',
                32: '-1437x385y1012z',
                33: '-1439x133y1072z',
                34: '-1465x311y997z',
                35: '-1489x235y982z',
                36: '-1489x938y374z',
                37: '-149x566y1702z',
                38: '-1509x158y967z',
                39: '-1525x79y951z',
                40: '-1535x61y1116z',
                41: '-1537x0y936z',
                42: '-1539x861y356z',
                43: '-1585x781y338z',
                44: '-1627x698y321z',
                45: '-1664x613y303z',
                46: '-1697x526y285z',
                47: '-1725x437y267z',
                48: '-1748x346y249z',
                49: '-1766x255y232z',
                50: '-1779x162y214z',
                51: '-1787x69y196z',
                52: '-184x573y1696z',
                53: '-191x1119y1396z',
                54: '-192x1216y1312z',
                55: '-197x1660y666z',
                56: '-21x7y1799z',
                57: '-220x579y1689z',
                58: '-252x1121y1385z',
                59: '-257x582y1683z',
                60: '-258x1217y1300z',
                61: '-285x1654y649z',
                62: '-294x583y1677z',
                63: '-314x1119y1373z',
                64: '-325x1214y1287z',
                65: '-333x581y1670z',
                66: '-372x1643y632z',
                67: '-372x577y1663z',
                68: '-377x1114y1362z',
                69: '-392x1208y1275z',
                70: '-39x10y1799z',
                71: '-411x570y1656z',
                72: '-440x1105y1350z',
                73: '-451x560y1649z',
                74: '-459x1197y1262z',
                75: '-459x1627y616z',
                76: '-491x548y1642z',
                77: '-4x1y1799z',
                78: '-503x1093y1338z',
                79: '-527x1183y1249z',
                80: '-530x533y1635z',
                81: '-546x1607y599z',
                82: '-54x531y1718z',
                83: '-565x1077y1326z',
                84: '-569x516y1627z',
                85: '-57x12y1799z',
                86: '-593x1165y1236z',
                87: '-608x496y1619z',
                88: '-628x1057y1313z',
                89: '-631x1581y582z',
                90: '-646x473y1611z',
                91: '-660x1143y1223z',
                92: '-684x447y1603z',
                93: '-690x1034y1301z',
                94: '-716x1551y565z',
                95: '-720x419y1595z',
                96: '-725x1117y1209z',
                97: '-750x1007y1289z',
                98: '-755x388y1586z',
                99: '-75x12y1798z',
                100: '-789x354y1578z',
                101: '-790x1087y1196z',
                102: '-799x1517y547z',
                103: '-810x976y1276z',
                104: '-821x318y1569z',
                105: '-84x545y1713z',
                106: '-851x279y1560z',
                107: '-853x1054y1183z',
                108: '-869x941y1263z',
                109: '-880x1477y530z',
                110: '-880x238y1551z',
                111: '-906x195y1542z',
                112: '-915x1016y1169z',
                113: '-926x903y1250z',
                114: '-931x150y1533z',
                115: '-93x10y1797z',
                116: '-952x103y1523z',
                117: '-959x1434y513z',
                118: '-972x54y1513z',
                119: '-975x975y1155z',
                120: '-981x862y1237z',
                121: '-988x3y1504z'}

#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1800five4xi" usage = "target function for charge18004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire1800five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1800FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1800FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1800FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1800FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1800FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five18004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1800FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1800FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1800FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five18004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five18004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1800FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1800FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1800FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1800five4xi.py                             
# -------------------------------------------------------------------------------------------------                